Page MenuHomeVyOS Platform

Support back-end L4 level load balancing
In progress, NormalPublicFEATURE REQUEST

Description

Let us consider whether it is possible to configure a load balancing scheme similar to LVS into the Vyos router

At least the following modes are supported:

  1. LVS-DR
  2. LVS-TUN
  3. LVS-NAT

Details

Difficulty level
Normal (likely a few hours)
Version
-
Why the issue appeared?
Will be filled on close
Is it a breaking change?
Unspecified (possibly destroys the router)

Event Timeline

jack9603301 triaged this task as Wishlist priority.Dec 5 2020, 12:44 PM
jack9603301 created this task.
jack9603301 updated the task description. (Show Details)
jack9603301 updated the task description. (Show Details)
jack9603301 changed Difficulty level from Unknown (require assessment) to Hard (possibly days).Jan 14 2021, 11:12 AM
jack9603301 changed the task status from Open to Confirmed.Jan 14 2021, 11:21 AM
jack9603301 claimed this task.
jack9603301 renamed this task from Support L4 level load balancing to Support back-end L4 level load balancing.Jan 27 2021, 9:09 AM
jack9603301 changed the task status from Confirmed to In progress.Jan 28 2021, 1:03 PM
jack9603301 moved this task from Need Triage to In Progress on the VyOS 1.3 Equuleus board.

PR: https://github.com/vyos/vyos-1x/pull/708

Development is continuing, so this PR is a draft

This draft currently defines a basic CLI

jack9603301 raised the priority of this task from Wishlist to Normal.Jan 28 2021, 2:00 PM
jack9603301 changed Difficulty level from Hard (possibly days) to Normal (likely a few hours).
jack9603301 changed the task status from In progress to Confirmed.Jan 30 2021, 12:43 PM
jack9603301 lowered the priority of this task from Normal to Wishlist.
jack9603301 moved this task from In Progress to Need Triage on the VyOS 1.3 Equuleus board.

@dmbaturin Hi, I would like to discuss with you the possibility of introducing load-balancing components based on direct-routing mode in VYOS. VYOS already has binary components that implement LVS

The preliminary idea is to use load-balancing inbound syntax for balancing load between multiple hosts inside the network (i.e. LVS) and load-balancing outbound for balancing connections between multiple WAN interfaces.

@c-po should review the PR draft.

jack9603301 changed the task status from Confirmed to In progress.Mon, Feb 22, 9:40 AM
jack9603301 raised the priority of this task from Wishlist to Normal.
jack9603301 moved this task from Need Triage to In Progress on the VyOS 1.4 Sagitta board.

Start implementing this draft

@dmbaturin @c-po Hi, I have basically completed the T3116 draft implementation, test, I only inspect the ipvsadm rules, seems to work properly, the draft only for ipvsadm, to set up some rules, now, you and @c-po can achieve the preliminary examination of the draft (about smoke tests, I currently only normal execution of the command line configuration program testing, has not yet been configured efficacy)